using CloudBuilder.Core.Authorization;
using CloudBuilder.Core.DatabaseAccessor.Entity;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
namespace CloudBuilder.AI.Entity
 {
    [TypeScript]
    [Table("ai_paragraph")]
    public class AiParagraphEntity : EntityBase<string>
    {

    public AiParagraphEntity() 
    {
    }

    [Column("created_datetime")]
    public DateTime CreatedDatetime  { get; set; }
    [Column("created_by")]
    public string CreatedBy  { get; set; }
    [Column("updated_datetime")]
    public DateTime UpdatedDatetime  { get; set; }
    [Column("updated_by")]
    public string UpdatedBy  { get; set; }
    [Key]
    [Column("guid")]
    public string Guid  { get; set; }
    [Column("chapter_guid")]
    public string ChapterGuid  { get; set; }
    [Column("paragraph_index")]
    public int ParagraphIndex  { get; set; }
    [Column("content")]
    public string Content  { get; set; }
    [Column("dialogue_indc")]
    public string? DialogueIndc  { get; set; }

    public const string CREATED_DATETIME = "CreatedDatetime";
    public const string CREATED_BY = "CreatedBy";
    public const string UPDATED_DATETIME = "UpdatedDatetime";
    public const string UPDATED_BY = "UpdatedBy";
    public const string GUID = "Guid";
    public const string CHAPTER_GUID = "ChapterGuid";
    public const string PARAGRAPH_INDEX = "ParagraphIndex";
    public const string CONTENT = "Content";
    public const string DIALOGUE_INDC = "DialogueIndc";

    public const string DB_NAME_AI_PARAGRAPH = "ai_paragraph";
    public const string DB_NAME_FIELDS="created_datetime,created_by,updated_datetime,updated_by,guid,chapter_guid,paragraph_index,content,dialogue_indc";

    public const string DB_CREATED_DATETIME = "created_datetime";
    public const string DB_CREATED_BY = "created_by";
    public const string DB_UPDATED_DATETIME = "updated_datetime";
    public const string DB_UPDATED_BY = "updated_by";
    public const string DB_GUID = "guid";
    public const string DB_CHAPTER_GUID = "chapter_guid";
    public const string DB_PARAGRAPH_INDEX = "paragraph_index";
    public const string DB_CONTENT = "content";
    public const string DB_DIALOGUE_INDC = "dialogue_indc";


    public static AiParagraphEntity GetInstance()
    {
        return new AiParagraphEntity();
    }

    public virtual void CopyFrom(AiParagraphEntity source)
    {
        CopyFrom(source, true);
    }

    public virtual void CopyFrom(AiParagraphEntity source, bool includeSystemFields)
    {
        if (source == null)
        {
            throw new NullReferenceException("Source entity is null.");
        }

        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        this.Guid =  source.Guid;
        this.ChapterGuid =  source.ChapterGuid;
        this.ParagraphIndex =  source.ParagraphIndex;
        this.Content =  source.Content;
        this.DialogueIndc =  source.DialogueIndc;

        if (includeSystemFields)
        {
        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        }
    }

    public override string GetSelectFrom()
    {
        return $" select {DB_NAME_FIELDS} from { DB_NAME_AI_PARAGRAPH}  with(nolock) ";
    }
	
    public override string GetSelectCountFrom(string sqlWhere)
    {
        return $" select count(*) from { DB_NAME_AI_PARAGRAPH}  with(nolock) where 1=1 {sqlWhere}";
    }
	
    public override string GetSelectTopFrom(int limit, int start,string orderby,string orderbytag,  string sqlWhere)
    {
            if (string.IsNullOrEmpty(orderbytag)  || orderbytag.Trim() != "desc") orderbytag = "asc";
            if (string.IsNullOrEmpty(orderby) || !DB_NAME_FIELDS.Contains(orderby)) orderby =  DB_GUID ;  		
		string top = limit > 0 ? $"top {limit}" : "";
        return $" select {top} {DB_NAME_FIELDS} from (select {DB_NAME_FIELDS}  ,row_number() over(order by {orderby} {orderbytag}) as num from { DB_NAME_AI_PARAGRAPH}  with(nolock) where 1=1 {sqlWhere} ) a where num> {limit * (start - 1)}";
    }

    public AiParagraphEntity Clone()
    {
        AiParagraphEntity result = new AiParagraphEntity();
        result.CopyFrom(this);

        return result;
    }

    }
}
